﻿Namespace AVB

    Public Class NachtScanner
        Private _ARGBPx() As Integer
        Private _LastStart As Integer = 0

        Public Sub SetImageData(NewARGBPx() As Integer, ByVal NewImageSize As Size)
            If _ARGBPx Is Nothing Then
                _ARGBPx = NewARGBPx.Clone
            End If
            If _LastStart = 0 Then
                _LastStart = 1
            Else
                _LastStart = 0
            End If


            'interlaced calculation - new value
            For i As Integer = _LastStart To NewARGBPx.Length - 1 Step 2
                Dim NewColor As Integer = NewARGBPx(i)
                Dim A As Integer = NewColor >> 24
                Dim R As Integer = (NewColor And &HFF0000) >> 16
                Dim G As Integer = (NewColor And &HFF00) >> 8
                Dim B As Integer = (NewColor And &HFF)

                If R > 150 Then
                    R = Math.Min(255, R * 1.5)
                    G = G / 2
                    B = B / 2
                End If

                NewColor = ((A And &HFF) << 24) Or ((R And &HFF) << 16) Or ((G And &HFF) << 8) Or (B And &HFF)
                NewARGBPx(i) = NewColor
                _ARGBPx(i) = NewColor
            Next

            'interlaced calculation - old value
            For i As Integer = (1 - _LastStart) To NewARGBPx.Length - 1 Step 2
                NewARGBPx(i) = _ARGBPx(i)
            Next

        End Sub

    End Class
End Namespace